/*--------------------------------------------------------------------------*/
/* Programa para tratamento de transformacao de chaves (hash)               */
/*                                                                          */
/* Adaptado de Wirth, Algoritmos e estruturas de dados                      */
/*--------------------------------------------------------------------------*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define TRUE         1
#define FALSE        0
#define P           97     /* primo, dimensao da tabela */
#define TAMPALAVRA  16
#define LIVRE     NULL

typedef struct Item* itemptr;

struct Palavra {
        char chave[TAMPALAVRA];
        itemptr primeiro,ultimo;
};

struct Item {
        int nroLinha;
        itemptr proximo;
};

int    linha;
char   trab[TAMPALAVRA];
struct Palavra T[P];         /* tabela de mapeamento */

/*--------------------------------------------------------------------------*/
/* Funcao de impressao da tabela de mapeamento                              */
/*--------------------------------------------------------------------------*/

void ImprimeTabela(void) {
        int     i,k,m;
        itemptr item;

        for (k=0;k<P;k++) {

                if (T[k].chave[0] != '\0') {

                        printf("chave %d palavra %s",k,T[k].chave);
                        item = T[k].primeiro;
                        m = 0;
                        do {
                                if (m==8) {
                                        printf("\n");
                                        m = 0;
                                        for (i=0;i<TAMPALAVRA;i++)
                                                printf(" ");
                                }
                                m++;
                                printf(", linha %d",item->nroLinha);
                                item = item->proximo;
                        } while (item != NULL);
                        printf("\n");
                }
        }
}

/*--------------------------------------------------------------------------*/
/* Funcao de pesquisa                                                       */
/*--------------------------------------------------------------------------*/

void Pesquisa(char *trab) {
        int     i,h,d,encontrou;
        itemptr x;
        div_t   s;

        /* calcula o ndice de mapeamento h para a palavra contida em trab */

        i = h = 0;

        while (trab[i] != '\0') {
                s = div(256*h + trab[i++], P);
                h = s.rem;
        }

        x = (itemptr) malloc(sizeof(struct Item));
        x->nroLinha = linha;
        x->proximo = NULL;
        d = 1;
        encontrou = FALSE;

        do {
                if (strcmp(T[h].chave,trab) == 0) {  /* coincidencia */

                        encontrou = TRUE;
                        T[h].ultimo->proximo = x;
                        T[h].ultimo = x;
                }
                else if (T[h].chave[0] == '\0') {    /* nova entrada */

                        strcpy(T[h].chave,trab);
                        T[h].primeiro = x;
                        T[h].ultimo = x;
                        encontrou = TRUE;
                }
                else {                               /* coliso */

                        h += d;
                        d += 2;
                        if (h >= P) h -= P;
                        if (d == P) {
                                printf("Excedida a capacidade da tabela\n");
                                exit(1);
                        }
                }
        } while (!encontrou);
}

/*-----------------------------------------------------------------------*/
/* Funcao principal                                                      */
/*-----------------------------------------------------------------------*/

void main(void) {
        int i;

        clrscr();
        linha = 0;
        for (i=0;i<P;i++)
                T[i].chave[0] = '\0';

        do {
                printf("Forneca a proxima palavra (<enter>=fim):");
                gets(trab);

                if (trab[0] != '\0') {
                        linha++;
                        Pesquisa(trab);
                }
        } while (trab[0] != '\0');

        ImprimeTabela();
}
