/*----------------------------------------------------------------------------*/
/* Programa para a insercao e pesquisa de nos em arvores balanceadas          */
/*                                                                            */
/* Adaptado de Wirth, Algoritmos e estruturas de dados                        */
/*----------------------------------------------------------------------------*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define TRUE  1
#define FALSE 0

typedef struct No* noptr;

struct No {
        int valor;
        int contador;
        int bal;
        noptr esquerda;
        noptr direita;
};

/*----------------------------------------------------------------------------*/
/* Funcao de impressao da arvore                                              */
/*----------------------------------------------------------------------------*/

void ImprimeArvore (noptr t, int h) {
        int i;

        if (t) {

                ImprimeArvore(t->esquerda,h+1);
                for (i=0;i<h;i++) printf(" ");
                printf("%d com %d ocorrencia(s)\n",t->valor,t->contador);
                ImprimeArvore(t->direita,h+1);
        }
}

/*----------------------------------------------------------------------------*/
/* Funcao de montagem da arvore                                               */
/*----------------------------------------------------------------------------*/

void Pesquisa (int x,noptr* p, int *h) {
noptr p1,p2;

        if (*p == NULL) {

                *h = TRUE;
                *p = (noptr) malloc(sizeof(struct No));
                (*p)->valor    = x;
                (*p)->contador = 1;
                (*p)->esquerda = NULL;
                (*p)->direita  = NULL;
                (*p)->bal = 0;
        }

        else if (x < (*p)->valor) {
                Pesquisa(x,&((*p)->esquerda),h);
                if (*h) {                             /* o ramo esq cresceu */
                        switch ((*p)->bal) {
                                case 1: (*p)->bal = 0;
                                        *h = FALSE;
                                        break;
                                case 0: (*p)->bal = -1;
                                        break;
                                case -1:p1 = (*p)->esquerda;  /* rebalanceamento */
                                        if (p1->bal == -1) {  /* rotacao simples esq */
                                                (*p)->esquerda = p1->direita;
                                                p1->direita = *p;
                                                (*p)->bal = 0;
                                                *p = p1;
                                        }
                                        else {  /* rotacao dupla esq-dir */
                                                p2 = p1->direita;
                                                p1->direita = p2->esquerda;
                                                p2->esquerda = p1;
                                                (*p)->esquerda = p2->direita;
                                                p2->direita = *p;
                                                if (p2->bal == -1)
                                                        (*p)->bal = 1;
                                                else
                                                        (*p)->bal = 0;
                                                if (p2->bal == 1)
                                                        p1->bal = -1;
                                                else
                                                        p1->bal = 0;
                                                *p = p2;
                                        }
                                        (*p)->bal = 0;
                                        *h = FALSE;
                                        break;
                        }

                }
        }
        else if (x > (*p)->valor) {
                Pesquisa(x,&((*p)->direita),h);
                if (*h) {                             /* o ramo dir cresceu */
                        switch((*p)->bal) {
                                case -1:(*p)->bal = 0;
                                        *h = FALSE;
                                        break;
                                case 0: (*p)->bal = 1;
                                        break;
                                case 1: p1 = (*p)->direita; /* rebalanceamento */
                                        if (p1->bal == 1) { /* rotacao simples dir */
                                                (*p)->direita = p1->esquerda;
                                                p1->esquerda = *p;
                                                (*p)->bal = 0;
                                                *p = p1;
                                        }
                                        else { /* rotacao dupla dir-esq */
                                                p2 = p1->esquerda;
                                                p1->esquerda = p2->direita;
                                                p2->direita = p1;
                                                (*p)->direita = p2->esquerda;
                                                p2->esquerda = *p;
                                                if (p2->bal == 1)
                                                        (*p)->bal = -1;
                                                else
                                                        (*p)->bal = 0;
                                                if (p2->bal == -1)
                                                        p1->bal = 1;
                                                else
                                                        p1->bal = 0;
                                                *p = p2;
                                        }
                                        (*p)->bal = 0;
                                        *h = FALSE;
                                        break;
                        }
                }
        }
        else (*p)->contador++;
}

/*----------------------------------------------------------------------------*/
/*                                Funcao principal                            */
/*----------------------------------------------------------------------------*/

void main() {
        int i,N,valor,h;
        noptr Raiz;
        char str[10];

        clrscr();
        Raiz = NULL;
        printf("Indique o numero de nos a ler (0=fim): ");

        gets(str);
        sscanf(str,"%d",&N);

        for (i=1;i<=N;i++){
                printf("Forneca o no %d: ",i);
                gets(str);
                valor = atoi(str);
                Pesquisa(valor,&Raiz,&h);
        }

        ImprimeArvore(Raiz,0);
}

