/*----------------------------------------------------------------------------*/
/* Programa para a insercao, pesquisa e remocao de nos em arvores binarias    */
/* perfeitamente balanceadas                                                  */
/* Adaptado de Wirth, Algorimos e estruturas de dados                         */
/*----------------------------------------------------------------------------*/

#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct No* noptr;

struct No {
        int valor;
        int contador;
        noptr esquerda;
        noptr direita;
};

/*----------------------------------------------------------------------------*/
/* Funcao de impressao da arvore                                              */
/*----------------------------------------------------------------------------*/

void ImprimeArvore (noptr t, int h) {
        int i;

        if (t) {

                ImprimeArvore(t->esquerda,h+1);
                for (i=0;i<h;i++) printf(" ");
                printf("%d com %d ocorrencia(s)\n",t->valor,t->contador);
                ImprimeArvore(t->direita,h+1);
        }
}

/*----------------------------------------------------------------------------*/
/* Funcao de montagem da arvore                                               */
/*----------------------------------------------------------------------------*/

void Pesquisa (int x,noptr* p) {

        if (*p == NULL) {

                *p = (noptr) malloc(sizeof(struct No));
                (*p)->valor    = x;
                (*p)->contador = 1;
                (*p)->esquerda = NULL;
                (*p)->direita  = NULL;
        }

        else if (x < (*p)->valor)
                        Pesquisa(x,&((*p)->esquerda));
             else if (x > (*p)->valor)
                        Pesquisa(x,&((*p)->direita));
                  else (*p)->contador++;
}

/*----------------------------------------------------------------------------*/
/* Funcao auxiliar de remocao                                                */
/*----------------------------------------------------------------------------*/

void del (noptr* q, noptr* r) {

        if ((*r)->direita != NULL)
                del(q,&((*r)->direita));
        else {
                (*q)->valor = (*r)->valor;
                (*q)->contador = (*r)->contador;
                *q = * r;
                *r = (*r)->esquerda;
        }
}

/*----------------------------------------------------------------------------*/
/* Funcao de remocao                                                          */
/*----------------------------------------------------------------------------*/

void Delete (int x, noptr* p) {

        noptr q;

        if (*p == NULL)
                printf("O no %d nao se encontra na arvore\n",x);
        else if (x < (*p)->valor)
                Delete(x,&((*p)->esquerda));
             else if (x > (*p)->valor)
                        Delete(x,&((*p)->direita));
                  else {
                                q = *p;
                                if (q->direita == NULL)
                                        *p = q->esquerda;
                                else if (q->esquerda == NULL)
                                        *p = q->direita;
                                     else del(&q,&(q->esquerda));
                  }
}


/*----------------------------------------------------------------------------*/
/*                                Funcao principal                            */
/*----------------------------------------------------------------------------*/

void main() {
        int i,N,valor;
        noptr Raiz;
        char str[10];

        clrscr();

        /* constroi a arvore */

        Raiz = NULL;
        printf("Indique o numero de nos a ler (<enter>=fim): ");

        gets(str);

        if (str[0] != '\0') {

                sscanf(str,"%d",&N);

                for (i=1;i<=N;i++){
                        printf("Forneca o no %d: ",i);
                        gets(str);
                        valor = atoi(str);
                        Pesquisa(valor,&Raiz);
                }

                ImprimeArvore(Raiz,0);

                /* remove nos da arvore */

                do {
                        printf("Forneca o no a remover (<enter> para encerrar): ");
                        gets(str);

                        if (str[0] != '\0') {
                                valor = atoi(str);
                                Delete(valor,&Raiz);
                                ImprimeArvore(Raiz,0);
                        }
                } while (str[0] != '\0');
        }                
}


